## a56 1.3

=== Makefile ===
STUFF = caltone.omf memtest.omf pink.omf sloader.omf test-dac.omf \
	test-int.omf thru.omf reverb.omf flange.omf chorus.omf sixcomb.omf

M4 = m4
CPP = /lib/cpp

all:	$(STUFF)

clean:	; rm -f *.out *.omf *.lis tmp.a56 *.bak .jrc LOG ERR x.a56

sixcomb.omf:	sixcomb.a56
		$(M4) $*.a56 > x.a56
		make x.omf
		mv x.out sixcomb.out
		mv x.lis sixcomb.lis

.SUFFIXES:	.a56 .omf

.a56.omf:	$*.a56
		$(CPP) -Uicon $*.a56 > tmp.a56
		a56 -o $*.out tmp.a56 > $*.lis
		rm tmp.a56
		toomf < $*.out > $*.omf

## a56 1.3%2Bdfsg

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg// \
	http://www.zdomain.com/a56.html a56/a56v(\d\.\d)\.tar.gz

## a56 1.3+dfsg

=== Makefile ===
#######################################################
#
#  a56 - a DSP56001 assembler
#
#  Written by Quinn C. Jensen
#  July 1990
#
#######################################################

# environment definitions
# uncomment the ones you like

# generic unix
CC = cc
HOSTCC = cc
YACC = yacc
CCDEFS = -DLDEBUG
MV = mv
YTABC = y.tab.c
YTABH = y.tab.h
POSTPROCESS = echo

# gcc & bison
#CC = gcc
#HOSTCC = gcc
#YACC = bison -y
#CCDEFS =
#MV = mv
#YTABC = y.tab.c
#YTABH = y.tab.h
#POSTPROCESS = echo

# Delorie's DOS gcc (from ftp://omnigate.clarkson.edu/pub/msdos/djgpp)
#CC = gcc
#HOSTCC = gcc
#YACC = bison -y
#CCDEFS =
#MV = ren
#YTABC = y_tab.c
#YTABH = y_tab.h
#POSTPROCESS = coff2exe

# gcc cross-compile to go32 environment
#CC = i386-go32-gcc
#HOSTCC = cc
#YACC = yacc
#CCDEFS =
#MV = mv
#YTABC = y.tab.c
#YTABH = y.tab.h
#POSTPROCESS = echo

#######################################################

# -O or -g
#DEBUG = -O -Olimit 3000
DEBUG = -O

SRCS = main.c a56.y lex.c subs.c getopt.c kparse.key
OBJS = main.o gram.o lex.o toktab.o subs.o getopt.o kparse.o

DEFINES = $(CCDEFS)
#DEFINES = -DYYDEBUG -DLDEBUG $(CCDEFS)

CFLAGS = $(DEBUG) $(DEFINES)

all:	keybld a56 toomf

a56:	$(OBJS)
	$(CC) $(CFLAGS) -o a56 $(OBJS) -lm
	@$(POSTPROCESS) a56

keybld:	keybld.o ksubs.o
	$(HOSTCC) $(CFLAGS) -o keybld keybld.o ksubs.o
	@$(POSTPROCESS) keybld

keybld.o:	keybld.c
	$(HOSTCC) $(CFLAGS) -c keybld.c

ksubs.o:	subs.c
	$(HOSTCC) $(CFLAGS) -c subs.c
	$(MV) subs.o ksubs.o

lex.o:	lex.c gram.h

kparse.c:	a56.key keybld
	keybld < a56.key > kparse.c

gram.c gram.h:	a56.y
	@echo "[expect 2 shift/reduce conflicts here]"
	$(YACC) -d a56.y
	$(MV) $(YTABC) gram.c
	$(MV) $(YTABH) gram.h

toktab.c:	gram.h
	awk -f tok.awk < gram.h > toktab.c

y.output:	a56.y
	$(YACC) -v a56.y

toomf:	toomf.o
	$(CC) -o toomf $(CFLAGS) toomf.o
	@$(POSTPROCESS) toomf

torom:	torom.o subs.o
	$(CC) -o torom $(CFLAGS) torom.o subs.o

tape:	toktab.c
	csh -c 'tar cvbf 1 - `cat files` | gzip > a56.tar.gz'

main.o gram.o lex.o:	a56.h

clean:	; rm -f a56 toomf y.output *.o *.out tmp *.bak a56.tar.gz keybld

spotless:	clean
	rm -f gram.c lexyy.c gram.h toktab.c kparse.c

=== debian/changelog ===
a56 (1.3+dfsg-12) unstable; urgency=medium

  * add debian/gbp.conf
  * activate salsa-ci.yml
  * convert debian/copyright to dep5

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 09 Nov 2024 17:00:00 +0100

a56 (1.3+dfsg-11) unstable; urgency=medium

  [ Ben Hutchings ]
  * Update patches to fix new errors in gcc-14 (Closes: #1074798):
    - Drop "non-void should return a value bug in main." (clang-ftbfs.diff)
      as the affected function should actually return void
    - Replace the many partial function declaration patches with a single
      patch that fixes all missing prototypes and K&R style definitions
  * Drop "Replace undeclared fatal" (replace-undecl-fatal.patch), as
    fatal() is now declared
  * Add format attributes to allow type checks on *printf() wrappers
  * Enable most compiler warnings (-Wall -Wextra with some overrides)
  * Fix remaining warnings in upstream code with gcc-14
  * a56-tobin: Check for errors from pwrite()
  * Add debian/.gitgnore file to make 'git add debian' safer

  [ Thorsten ]
  * debian/control: bump standard to 4.7.0 (no changes)
  * debian/watch: use version 4
  * fix spelling in patch description
  * mark patches such that forwarding is not needed

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 28 Jul 2024 23:00:00 +0200

a56 (1.3+dfsg-10.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use standard strtol.
  * Fix a lot of implicit-function-declarations. (Closes: #1066195)

 -- Bastian Germann <bage@debian.org>  Sat, 16 Mar 2024 20:29:00 +0000

a56 (1.3+dfsg-10) unstable; urgency=medium

  [ debian janitor ]
  * Trim trailing whitespace.
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Use canonical URL in Vcs-Browser.

  [ Thorsten ]
  * debian/control: bump standard to 4.6.2 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 13 Jan 2024 23:00:00 +0100

a56 (1.3+dfsg-9) unstable; urgency=low

  * debian/control: use dh11
  * debian/control: bump standard to 4.1.3 (no changes)
  * debian/control: use Priority: optional
  * debian/control: add salsa URLs
  * debian/patches: finally remove unused patches
  * debian/rules: add hardening flags
  * debian/rules: add --no-parallel

 -- Thorsten Alteholz <debian@alteholz.de>  Tue, 20 Feb 2018 18:00:00 +0100

a56 (1.3+dfsg-8) unstable; urgency=low

  * Fix the FTBFS with clang:,  (Closes: #739929)
    - Fixed non-void should return a value bug in main.c
      (patch by Arthur Marble)
  * debian/control: bump standrad to 3.9.5 (no changes)

 -- Thorsten Alteholz <debian@alteholz.de>  Sun, 23 Mar 2014 18:00:00 +0100

a56 (1.3+dfsg-7) unstable; urgency=low

  * new maintainer (Closes: #594375)
  * copyright of examples is not clear so I removed them
    source tarball re-packed also to be able to work with quilt
  * debian/source/format: add 3.0 (quilt)
  * debian/compat: change to 9
  * debian/control: dh 9
  * debian/control: remove cdbs dependency
  * debian/copyright: change link to file and insert 'Copyright'
  * debian/watch: add file
  * debian/patches: rework patches for quilt
  * debian/patches/pc-type.patch: change type of variable (Closes: #689364)

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 26 Nov 2012 18:00:00 +0100

a56 (1.3-6) unstable; urgency=low

  * QA upload, set maintainer to Debian QA group
  * Fix typo (Closes: #503842)
  * Add manpage created by Denis Briand (Closes: #579595)

 -- Moritz Muehlenhoff <jmm@inutil.org>  Fri, 10 Jun 2011 00:32:20 +0200

a56 (1.3-5) unstable; urgency=high

  * patches/04_add_missing_prototypes.diff: Add missing prototypes for
    alloc() and fixstring().  (Closes: #503698)
  * bin2h.c: Refurbish CLI to make it more flexible.

 -- Robert Millan <rmh@aybabtu.com>  Mon, 27 Oct 2008 21:39:44 +0100

a56 (1.3-4) unstable; urgency=high

  * Add bin2h for binary to C-header conversion.

 -- Robert Millan <rmh@aybabtu.com>  Sun, 26 Oct 2008 17:00:38 +0100

a56 (1.3-3) unstable; urgency=high

  * Add a56- prefix to tobin, toomf and keybld.

 -- Robert Millan <rmh@aybabtu.com>  Sun, 26 Oct 2008 13:54:06 +0100

a56 (1.3-2) unstable; urgency=high

  * Build-depend on bison.

 -- Robert Millan <rmh@aybabtu.com>  Tue, 21 Oct 2008 17:35:19 +0200

a56 (1.3-1) unstable; urgency=high

  * Initial release.  (Closes: #502508)

 -- Robert Millan <rmh@aybabtu.com>  Mon, 20 Oct 2008 15:03:37 +0000

=== debian/control ===
Source: a56
Section: devel
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13), bison
Standards-Version: 4.7.0
Homepage: http://www.zdomain.com/a56.html
Vcs-Browser: https://salsa.debian.org/alteholz/a56
Vcs-Git: https://salsa.debian.org/alteholz/a56.git
Rules-Requires-Root: no
#not really needed: Testsuite: autopkgtest

Package: a56
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Motorola DSP56001 assembler
 a56 is an assembler for the Motorola DSP56001 family of microcontrollers.
 .
 It is capable of compiling the firmware used in Linux' dsp56k.c driver.
 .
 Example DSP code for musical effects such as chorus, flange, and reverb
 can be found at http://www.zdomain.com/a56/src/examples/ (unfortunately
 copyright prevents distribution).

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -Wextra -Wno-comment -Wno-parentheses -Wno-unused-variable

%:
	dh $@ --no-parallel

override_dh_clean:
	dh_clean
	rm -f gram.c gram.h
	rm -f toktab.c kparse.c
	rm -f a56-keybld a56-toomf
	rm -f debian/bin2h debian/a56-tobin
	rm -f debian/bin2h.o debian/a56-tobin.o
	rm -f bin2h a56-tobin

override_dh_auto_build:
	dh_auto_build

override_dh_install:
	mv keybld a56-keybld
	mv toomf a56-toomf
	dh_install

=== debian/watch ===
version=4

opts=dversionmangle=s/\+dfsg// \
	http://www.zdomain.com/a56.html a56/a56v(\d\.\d)\.tar.gz
